-------------------------------------------------------------------------------
--
-- Copyright (C) 2011
-- ASTRON (Netherlands Institute for Radio Astronomy) <http://www.astron.nl/>
-- P.O.Box 2, 7990 AA Dwingeloo, The Netherlands
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-------------------------------------------------------------------------------

LIBRARY IEEE, common_lib;
USE IEEE.STD_LOGIC_1164.ALL;
USE common_lib.common_pkg.ALL;
USE IEEE.NUMERIC_STD.ALL;     

PACKAGE reorder_pkg IS  

  TYPE t_reorder_seq IS RECORD 
    wr_chunksize    : POSITIVE; -- := 64;
    rd_chunksize    : POSITIVE; -- := 16;
    rd_nof_chunks   : POSITIVE; -- := 4;
    rd_interval     : POSITIVE; -- := 1;   
    gapsize         : NATURAL;  -- := 0;
    nof_blocks      : POSITIVE; -- := 5;   
  END RECORD;

  CONSTANT c_reorder_seq : t_reorder_seq := (64, 16, 4, 1, 0, 5);  
  
END reorder_pkg;

PACKAGE BODY reorder_pkg IS   

END reorder_pkg;

