import multiprocessing

NOF_PARALLEL_STREAMS = range(1000)

def sink(inst_number, p_snk,p_src):
    p_src.close() # Close this local connection to source end of the pipe
    my_list = []
    while True:
        try:
            item = p_snk.recv()
            #print inst_number, item
        except EOFError:
            break
        my_list.append(item**3)


def source(p_snk,p_src):
    p_snk.close() # Close this local connection to the sink end of the pipe
    for item in xrange(2000000):
        p_src.send(item)
    p_src.close()

if __name__ == '__main__':

    pipes = []
    sinks = []
    sources = []

    for i in NOF_PARALLEL_STREAMS:

        # Create pipe and return connections to the source and sink sides of the pipe
        pipes.append( multiprocessing.Pipe(duplex=False) )
    
        # Separate sink process
        sinks.append( multiprocessing.Process(target=sink, args=(i, pipes[i][0], pipes[i][1])) )
        sinks[i].start()
    
        # Separate source process
        sources.append( multiprocessing.Process(target=source, args=(pipes[i][0], pipes[i][1])) )
        sources[i].start()

